Subject: bug#46493: [feature/pgtk] Low contrast region face

From: "Basil L. Contovounesios" <[email-masked]>
Date: Sun, 14 Feb 2021 13:00:59 +0000

Yuuki Harano <[email-masked]> writes:

> On Sat, 13 Feb 2021 16:55:47 +0000,
> 	"Basil L. Contovounesios" <[email-masked]> wrote:
>> I understand that each toolkit has its look & feel, and that colour
>> perception is subjective, but the default contrast on pgtk strikes me as
>> a bit too low for text editing.
>
> lisp/faces.el:
>
> (defface region
>   '((((class color) (min-colors 88) (background dark))
>      :background "blue3" :extend t)
>     (((class color) (min-colors 88) (background light) (type gtk))
>      :distant-foreground "gtk_selection_fg_color"
>      :background "gtk_selection_bg_color" :extend t)
>
> The color name "gtk_selection_bg_color" is handled by src/gtkutil.c:
> xg_check_special_colors(), which gets colors from gtk theme.

Thanks.

> This issue is not pgtk-specific.

Indeed, but I thought it was worthwhile asking since pgtk seems primed
to be the future of GTK3 in Emacs mainline.  Let me know if I should
take this discussion elsewhere.

> If we want another color for bg on pgtk, we can change this face definition as follows:
>
> (defface region
>   '((((class color) (min-colors 88) (background dark))
>      :background "blue3" :extend t)
>     (((class color) (min-colors 88) (background light) (type pgtk))    ; add this line
>      :background "lightgoldenrod2" :extend t)                          ; add this line
>     (((class color) (min-colors 88) (background light) (type gtk))
>      :distant-foreground "gtk_selection_fg_color"
>      :background "gtk_selection_bg_color" :extend t)

Sounds fine to me, but I'm wondering if this shouldn't be fixed lower
down.  Out of curiosity, I installed another GTK editor, Gedit:

0. gedit
1. foo bar RET baz

Note how the current line is highlighted with the same background colour
as the active region in pgtk.

2. S-<up>

Note how Gedit's "region" takes on a different, much clearer colour.
Could/should Emacs query GTK3 colours differently here?

Thanks,

-- 
Basil